<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <meta name="author" content="Piers Calderwood" />
  <title>Correlated-Q Learning</title>
  <style>
    html {
      line-height: 1.5;
      font-family: Georgia, serif;
      font-size: 20px;
      color: #1a1a1a;
      background-color: #fdfdfd;
    }
    body {
      margin: 0 auto;
      max-width: 36em;
      padding-left: 50px;
      padding-right: 50px;
      padding-top: 50px;
      padding-bottom: 50px;
      hyphens: auto;
      word-wrap: break-word;
      text-rendering: optimizeLegibility;
      font-kerning: normal;
    }
    @media (max-width: 600px) {
      body {
        font-size: 0.9em;
        padding: 1em;
      }
    }
    @media print {
      body {
        background-color: transparent;
        color: black;
        font-size: 12pt;
      }
      p, h2, h3 {
        orphans: 3;
        widows: 3;
      }
      h2, h3, h4 {
        page-break-after: avoid;
      }
    }
    p {
      margin: 1em 0;
    }
    a {
      color: #1a1a1a;
    }
    a:visited {
      color: #1a1a1a;
    }
    img {
      max-width: 100%;
    }
    h1, h2, h3, h4, h5, h6 {
      margin-top: 1.4em;
    }
    h5, h6 {
      font-size: 1em;
      font-style: italic;
    }
    h6 {
      font-weight: normal;
    }
    ol, ul {
      padding-left: 1.7em;
      margin-top: 1em;
    }
    li > ol, li > ul {
      margin-top: 0;
    }
    blockquote {
      margin: 1em 0 1em 1.7em;
      padding-left: 1em;
      border-left: 2px solid #e6e6e6;
      color: #606060;
    }
    code {
      font-family: Menlo, Monaco, 'Lucida Console', Consolas, monospace;
      font-size: 85%;
      margin: 0;
    }
    pre {
      margin: 1em 0;
      overflow: auto;
    }
    pre code {
      padding: 0;
      overflow: visible;
    }
    .sourceCode {
     background-color: transparent;
     overflow: visible;
    }
    hr {
      background-color: #1a1a1a;
      border: none;
      height: 1px;
      margin: 1em 0;
    }
    table {
      margin: 1em 0;
      border-collapse: collapse;
      width: 100%;
      overflow-x: auto;
      display: block;
      font-variant-numeric: lining-nums tabular-nums;
    }
    table caption {
      margin-bottom: 0.75em;
    }
    tbody {
      margin-top: 0.5em;
      border-top: 1px solid #1a1a1a;
      border-bottom: 1px solid #1a1a1a;
    }
    th {
      border-top: 1px solid #1a1a1a;
      padding: 0.25em 0.5em 0.25em 0.5em;
    }
    td {
      padding: 0.125em 0.5em 0.25em 0.5em;
    }
    header {
      margin-bottom: 4em;
      text-align: center;
    }
    #TOC li {
      list-style: none;
    }
    #TOC a:not(:hover) {
      text-decoration: none;
    }
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
</head>
<body>
<header id="title-block-header">
<h1 class="title">Correlated-Q Learning</h1>
<p class="author">Piers Calderwood</p>
</header>
<h1 id="introduction">Introduction</h1>
<p>In Greenwald 2003, Greenwald describes and analyzes a novel Q-learning agent based on the correlated equilibrium for multi-agent repeated games. The algorithm, CE-Q, generalizes on existing Friend-and-Foe-Q agents, providing as-good or better results on general-sum games <span class="citation" data-cites="Littman:2001"></span><span class="citation" data-cites="Greenwald:2003"></span>. In this paper I will implement one of the constant-sum Markov games and reproduce its findings when played by competing deterministic-Q, Friend-Q, Foe-Q, and CE-Q agents. In addition, I will discuss the various agents, the outcomes, and the difficulties reproducing.</p>
<h1 id="environment">Environment</h1>
<figure>
<img src="soccer_env.png" id="fig:fig1" alt="Example game in state s" /><figcaption aria-hidden="true">Example game in state <span class="math inline"><em>s</em></span></figcaption>
</figure>
<p>The game that I was reproduce is the “Soccer" environment, a constant-sum Markov grid game. The grid is a 6x2 rectangle with 4 neutral squares in the center and two squares on either end serving as an agent’s goal. In the game, two agents compete to score by carrying a ball into their own goal. Scoring results in a +100 reward for the goal’s owner and -100 for the opponent. Each agent may move in one of the 4 cardinal directions or “stick" in place. At each time-step the agents perform their actions in a random order. If the players would end in the same tile and the second agent to move is carrying the ball, then the ball is “dropped" and moves into the other agent’s possession. Actions are therefore not deterministic; the probability of successfully applying the chosen action will depend on the other agent’s action. I also assume, as it is not made explicit in the paper, that agents cannot exist on the same tile. This means that only the first player to move will actually advance, or the player to stick if either sticks. The grid game was implemented using the multi-grid library <span class="citation" data-cites="multigrid:2020"></span>.</p>
<p>At the beginning of each game, the agents’ positions are randomized within the 4 neutral squares, pictured as the black squares between the colored goals, with the ball in the possession of a random agent. An example of the game is visible in Figure 1; Agent 1 is in green and agent 2 is blue and carrying the ball. This game state will be referred to as state <span class="math inline"><em>s</em></span> from now on and will serve as the basis for the experiments. State <span class="math inline"><em>s</em></span> is interesting because agents will learn a different "optimal" policy depending on how they consider opponent actions.</p>
<h1 id="experiment">Experiment</h1>
<p>The experiment I reproduced is a measurement of the convergence for 4 different types of agent on the Soccer environment. The hypothesis we will be testing is if the new CE-Q algorithm is able to generalize Foe-Q, either equally or surpassing its performance. In each experiment the two agents utilize the same learning algorithm. The 4 different agents tackle the problem of multi-agent games differently, which changes their convergence behavior. Specifically, I will be measuring the error in the <span class="math inline"><em>Q</em></span> value of each agent at state <span class="math inline"><em>s</em></span> when agent 1 (green) moves south and agent 2 (blue) “sticks" in place across 1 million “Simulation Iterations".</p>
<p>A simulation iteration is one of several ambiguous explained elements of the experiment. It could mean either a single step in the game or it could mean a complete game round. I implemented the experiments to run for 1 steps based on the sparsity of the Q-learning graph.</p>
<p>Error is recorded per iteration, the formula is given in Equation 1. Iterations with zero error are dropped as most steps did not occur in state <span class="math inline"><em>s</em></span>. I believe this is what the original paper does as well given the continuous behavior in their learning curves. The resulting errors are plotted across the episodes in blue. The orange line shows the decay of the learning rate. For space consideration, the original graphs have not been duplicated here.</p>
<p><span class="math display">ERR<sub>1</sub><sup><em>t</em></sup> = |<em>Q</em><sub>1</sub><sup><em>t</em></sup>(<em>s</em>,[So,St])−<em>Q</em><sub>1</sub><sup><em>t</em> − 1</sup>(<em>s</em>,[So,St])|</span></p>
<p>There are some other hyper parameters used by the agents. The discount rate is set at <span class="math inline"><em>γ</em> = 0.9</span> for all agents because this was the value used in earlier experiments in the paper.</p>
<p>The learning rate is not well defined in the paper. The final value approached <span class="math inline"><em>α</em> = 0.001</span> in the paper’s other experiment but the starting value, the rate of decay, and method of decay are not specified. I decided to use an exponential decay starting at <span class="math inline"><em>α</em> = 1.0</span> and having it decay down to <span class="math inline">0.001</span> by the final episode. These results emulated the paper’s Q-learner so I reused them for the other agents.</p>
<p>Additionally, the Q-learner is trained on-policy. To allow for exploration, <span class="math inline"><em>ϵ</em></span>-greedy was used. The other experiments in Greewald et al. had <span class="math inline"><em>ϵ</em> → 0.001</span> so I assume this applied to Soccer as well. My Q-agent started with <span class="math inline"><em>ϵ</em> = 0.95</span> and decayed like the learning rate to <span class="math inline">0.001</span> by the final episode using exponential decay.</p>
<p>In the other experiment the other agents were trained off-policy, meaning they made random actions. I assumed the same was true for Soccer. As such they did not need an exploration strategy or to pick actions according to their learned distribution.</p>
<h1 id="agents">Agents</h1>
<p>Each agent utilizes Q-learning but with different Value functions <span class="math inline"><em>V</em>(<em>s</em>)</span>. The Value function is used to estimate the future value of a state and is part of the recursive definition of the Q-function, which is easier to learn in the limited action space.</p>
<p><span class="math display"><em>Q</em><sub><em>i</em> + 1</sub> ← <em>Q</em><sub><em>i</em></sub>(<em>s</em><sub><em>t</em></sub>,<em>a</em><sub><em>t</em></sub>) + <em>α</em> ⋅ <em>T</em><em>D</em></span> where <span class="math display"><em>T</em><em>D</em> = <em>r</em><sub><em>t</em></sub> + <em>γ</em><em>V</em>(<em>s</em><sub><em>t</em> + 1</sub>) − <em>Q</em><sub><em>i</em></sub>(<em>s</em><sub><em>t</em></sub>,<em>a</em><sub><em>t</em></sub>)</span> Note that Greenwald et al. use a slightly different but equivalent update definition.</p>
<p>In classic MDP Q-Learning, <span class="math inline"><em>V</em>(<em>s</em>) = max<sub><em>a</em></sub><em>Q</em>(<em>s</em>,<em>a</em>)</span>. The key difference between the agents is that they have different <span class="math inline"><em>V</em></span>. More intelligent agents will also take into account their possible opponent’s actions.</p>
<p>Initial Q estimates were randomized using a 0-mean normal distribution, but this appears not to affect convergence behavior or time.</p>
<h2 id="q-agent">Q-Agent</h2>
<figure>
<img src="q.png" id="fig:fig2" alt="Q-Agent training error" /><figcaption aria-hidden="true">Q-Agent training error</figcaption>
</figure>
<p>The first agent is a plain Q-learner. Its training error can be seen in figure 2. The most obvious result is that the learner has not converged. Much like in <span class="citation" data-cites="Greenwald:2003"></span>, the agent error does not reduce down to 0. The effect seen at the right hand of the graph is caused by the eventual decay of the learning rate. As demonstrated here, a Q-agent is poorly suited to a multi-agent game. This is because the Q-agent is unable to take into account the other agent’s actions and can only act deterministically, always picking the action which it estimates grants the highest future reward. This determinism allows the opponent to learn a counter strategy, reducing the effectiveness and expected payoff of the learned policy. Eventually this forces the Q-agent to learn a different policy to counter the counter, which is why it never converges.</p>
<p>In state <span class="math inline"><em>s</em></span>, agent 1 could learn that it should stick because agent 2 tries to move east. Eventually agent 2 will learn to counter this by moving south then east. If agent 2 always does this, it is better for agent 1 to move south in order to block. Which then makes the original policy for agent 2, moving east, more optimal. This causes an endless loop of policy improvement for the two agents. Because the two agents are deterministic they are unable to settle on an optimal policy leading to non-convergence.</p>
<p>Both my and Greenwald’s results show non-convergence, the tendency to zero coming from the decreasing learning rate. In both, there appears to be 3 “sub-curves" the error jumps between. One curve follows the maximum error. Another is near zero error and can be made out between the gaps of the extremes. Finally, there is a final middle curve, which is about half the magnitude of the larger and is most noticeable near the end of the experiment. I suspect the two larger curves are when agent 1 begins learning the new counter strategy after being exploited by the opponent. The agent is suddenly very wrong about its expectation for performing an action. Similarly, the lower error curve is when the agent is exploiting the opponent and before the opponent learns the correct action to counter. However, I was not able to corroborate this with graphs of the second agent’s learning curve.</p>
<p>A difference between the the graphs is my lower curve is not noticeable until around <span class="math inline">700, 000</span> iterations, while there is a period between <span class="math inline">350, 000 − 425, 000</span> where it is visible without the extremely high errors. Although not expressly said, the large gaps between extremes are probably because Greenwald has dropped zero error terms. The similar gaps in my graphs are from streaks of not performing the measure actions in state <span class="math inline"><em>s</em></span>. Therefore it is likely my results just did not have such an early or as long a streak without <span class="math inline"><em>s</em></span>.</p>
<p>Another difference is at the beginning of the experiment. In my results the error at the beginning rarely reached 0. In contrast, much of Greenwald’s early errors fluctuated between 0 and the maximum error. In both cases, there was rapid fluctuation in the error. This might be caused by different initial exploration rates or some other unknown difference between the two setups. However, in both cases the experiments demonstrate the main aim: that a Q-learner cannot converge.</p>
<h2 id="friend-q">Friend-Q</h2>
<figure>
<img src="friendq.png" id="fig:fig1" alt="Friend-Q training error" /><figcaption aria-hidden="true">Friend-Q training error</figcaption>
</figure>
<p>The next agent is an optimistic agent. Friend-Q is one of the algorithms introduced by Littman in his 2001 paper <span class="citation" data-cites="Littman:2001"></span>. Unlike naive Q-learning, the <span class="math inline"><em>V</em></span> function takes into account all agent actions. <span class="math inline"><em>V</em>(<em>s</em>) = max<sub><em>a</em></sub><em>Q</em>(<em>s</em>,<em>a⃗</em>)</span>, where <span class="math inline"><em>a⃗</em></span> is a vector of actions from all agents. It is called Friend-Q because it estimates the value of a state as the maximum of all possible outcomes. Agent 1 assumes the other agent, referred to as the opponent even under cooperation, will act in order to maximize agent 1’s reward. In purely cooperative games, where reward is shared, this is the correct behavior as maximizing other agents rewards is the same as maximizing your own reward.</p>
<p>However, Soccer is not such a game. Since both agents assume the other is acting selflessly, they have a unique interpretation of optimal play at state <span class="math inline"><em>s</em></span>. Agent 1 should assume that Agent 2, which is 1 step from scoring it a goal, will move west thereby scoring and granting Agent 1 +100 reward. Agent 1 is therefore indifferent in its action. Agent 2, also assuming Agent 1 is working cooperatively, and will attempt to pass the ball off to Agent 1 so that Agent 1 scores for it.</p>
<p>Both experiments show Friend-Q quickly converges and with very few examples. This is because the agents quickly settle on their “optimal" policies described above, falsely believing the opponent will act selflessly. Neither agent expects the actions of <span class="math inline">[</span>South, Stick<span class="math inline">]</span> and even a step later the agents will both act as they did previously, namely waiting for Agent 2 to score for Agent 1, and moving east to score for Agent 2 respectively. Thus the optimistic/expected reward doesn’t change for these action in <span class="math inline"><em>s</em></span>.</p>
<p>A key difference between our results is the rates of convergence. In Greenwald’s experiment, the Friend-Q agent converged to the answer in less than <span class="math inline">100, 000</span> steps. Mine did not reach 0 before almost <span class="math inline">500, 000</span> steps, although it had near zero error before <span class="math inline">200, 000</span> steps. It is possible that this is because of the initial learning rate. However, higher learning rates tended to be numerically unstable, so I was unable to verify if it would converge faster or smoother starting with <span class="math inline"><em>α</em> &gt; 1.0</span>.</p>
<h2 id="foe-q">Foe-Q</h2>
<figure>
<img src="foeq.png" id="fig:fig1" alt="Foe-Q training error" /><figcaption aria-hidden="true">Foe-Q training error</figcaption>
</figure>
<p>The next agent is also from Littman. Foe-Q uses a value function which assumes the opponent is trying to minimize our reward. In constant sum games like Soccer, where the opponents reward is the negative of our reward, this will result in optimal play. The value function uses maximin rather than regular max, <span class="math inline"><em>V</em>(<em>s</em>) = max<sub><em>a</em><sub>1</sub></sub>min<sub><em>a</em><sub>2</sub></sub><em>Q</em>(<em>s</em>,[<em>a</em><sub>1</sub>,<em>a</em><sub>2</sub>])</span>. The agents are trained off policy, making random actions but still converging to optimal policy. By the end of the experiment, Agent 1 learns a policy of moving South with probability <span class="math inline">0.282</span> and <span class="math inline">0.718</span> of Sticking while in state <span class="math inline"><em>s</em></span>. This policy lines up with our understanding of the game, as blocking the opponent is more advantageous than trying to move to the same square, which only has a 50% chance to steal and otherwise loses the games.</p>
<p>Both graphs line up very well with one another. The Foe-Q agents converge at around 600-700,000 steps. They have about the same regular convergence, dropping the error at approximately the same rate. The only drastic difference between the graphs are the early parts which I attribute to the line thickness and render size of my graphs.</p>
<p>This particular environment is well suited for Foe-Q, as there can be no cooperation between the two agents. This explains the well behaved error curve and why it is able to learn a successful policy against an equal adversary.</p>
<h2 id="ce-q">CE-Q</h2>
<figure>
<img src="ceq.png" id="fig:fig1" alt="CE-Q training error" /><figcaption aria-hidden="true">CE-Q training error</figcaption>
</figure>
<p>The last agent utilizes the learning algorithm proposed by <span class="citation" data-cites="Greenwald:2003"></span>, Correlation Equilibrium (CE) Q. The Correlation Equilibrium is a more general equilibrium than the Nash equilibrium (NE). Both describe agents’ probabilities over actions. The NE is a set of independent distributions, while CE is set of distributions over the joint probabilities between agents. For a general sum game, the NE will be contained in the set of CE. The CE has some useful properties which allow it to be used for learning multi-agent games. First, CE does not suffer from the same strict convergence criteria on repeated games. There is no known learning algorithm which in general converges to the NE. Second, it can be computed in polynomial time using a linear program allowing for efficient training. However, CE-Q is still more expensive than the other agents. Requiring 8-10x the training time as Foe-Q, the previously most expensive algorithm. For a more complex constant sum game or a game in which cooperation is rarely useful, it may be advantageous to use a Foe-Q agent to allow more training.</p>
<p>For a particular repeated game, there may be more than 1 equilibrium (Nash or Correlated). To allow selection of a specific equilibrium, the authors provide 4 variants of CE-Q for different equilibrium selection. The four are dubbed Utilitarian, Egalitarian, Republican, and Libertarian. For the experiment, Greenwald et al implemented the Utilitarian variant. However, because the game is constant sum, all four will arrive at the same equilibrium <span class="citation" data-cites="Greenwald:2003"></span>. Likewise, I implemented CE to use the Utilitarian form which attempts to maximize the sum of the player’s rewards.</p>
<p>The purpose of the experiment is to demonstrate that CE-Q generalizes Foe-Q, as an earlier experiment demonstrated that it generalizes Friend-Q. In <span class="citation" data-cites="Greenwald:2003"></span>, Foe-Q graph and CE-Q graph are identical. They most likelu used seeded RNG so that the two experiments had the exact same experiences. Because the game is zero-sum the CE value will be equal to the minimax as evidenced by the CE agent 1 converging to the same action probabilities as Foe-Q does. While I did not seed RNG, the CE error follows the same convergence behavior as Foe-Q. Like Foe-Q there are only minor differences which I believe are caused by cosmetic difference in the two charts rather than different convergence behavior.</p>
<h1 id="conclusion">Conclusion</h1>
<p>CE-Q allows an agent to learn both cooperative and opposing strategies without requiring two different value functions and in polynomial time. The experiments in Greenwald et al. demonstrated the generalization of CE-Q over Friend-Q and Foe-Q <span class="citation" data-cites="Greenwald:2003"></span>. My experimental results similarly show how well CE-Q handles the Soccer environment and how closely it follow Foe-Q’s convergence behavior. The results also demonstrate the need for purposeful algorithm beyond Q-learning which take into account the opponents actions.</p>
<div class="thebibliography">
<p><span>99</span> Fickinger, Arnaud <em>Multi-Agent Gridworld Environment for OpenAI Gym</em></p>
<p><code>https://github.com/ArnaudFickinger/gym-multigrid</code></p>
<p>Amy Greenwald, Keith Hall ICML’03 242-249 <em>Correlated-Q Learning</em></p>
<p><code>https://www.aaai.org/Papers/ICML/2003/ICML03-034.pdf</code></p>
<p>Micahel Littman ICML’01 322-328 <em>Friend-or-Foe Q-learning in General-Sum Games</em></p>
<p><code>https://dl.acm.org/doi/10.5555/645530.655661</code></p>
</div>
</body>
</html>
